Index: trunk/klask
===================================================================
--- trunk/klask	(revision 53)
+++ trunk/klask	(revision 54)
@@ -144,5 +144,5 @@
 
    my $fh = new Filehandle;
-   open $fh, '-|', "$cmd" or die "Can't exec $cmd\n";
+   open $fh, q{-|}, "$cmd" or die "Can't exec $cmd\n";
    my $result = <$fh>;
    close $fh;
@@ -155,6 +155,6 @@
 sub resolve_ip_arp_host {
    my $param_ip_or_host = shift;
-   my $interface = shift || '*';
-   my $type      = shift || 'fast';
+   my $interface = shift || q{*};
+   my $type      = shift || q{fast};
 
    my %ret = (
@@ -222,5 +222,5 @@
          push @paquets, "$chars[-2]$chars[-1]";
          }
-      $ret{mac_address} = join ':', @paquets;
+      $ret{mac_address} = join q{:}, @paquets;
       }
 
@@ -313,7 +313,7 @@
 
    my @paquets = split m/ : /xms, $arp;
-   my $return = '';
+   my $return = q{};
    foreach(@paquets) {
-      $return .= ".".hex_to_dec($_);
+      $return .= q{.} . hex_to_dec($_);
       }
    return $return;
@@ -324,5 +324,5 @@
 sub find_switch_port {
    my $arp             = shift;
-   my $switch_proposal = shift || '';
+   my $switch_proposal = shift || q{};
 
    my %ret;
@@ -333,5 +333,5 @@
 
    my @switch_search = @SWITCH;
-   if ($switch_proposal ne '') {
+   if ($switch_proposal ne q{}) {
       for my $sw (@SWITCH) {
          next if $sw->{hostname} ne $switch_proposal;
@@ -341,5 +341,5 @@
       }
 
-   my $research = "1.3.6.1.2.1.17.4.3.1.2".arp_hex_to_dec($arp);
+   my $research = '1.3.6.1.2.1.17.4.3.1.2' . arp_hex_to_dec($arp);
 
    LOOP_ON_SWITCH:
@@ -675,5 +675,5 @@
             }
 
-         my $switch_proposal = '';
+         my $switch_proposal = q{};
          if (exists $computerdb->{$resol_arp{ipv4_address}} and exists $computerdb->{$resol_arp{ipv4_address}}{switch_hostname}) {
             $switch_proposal = $computerdb->{$resol_arp{ipv4_address}}{switch_hostname};
@@ -1048,8 +1048,8 @@
       next LOOP_ON_IP_ADDRESS if $computerdb->{$ip}{hostname_fq} eq ($computerdb->{$ip}{switch_hostname} || $computerdb->{$ip}{switch_description}); # switch on himself !
 
-      my $sw_hostname = $computerdb->{$ip}{switch_hostname} || '';
+      my $sw_hostname = $computerdb->{$ip}{switch_hostname} || q{};
       next if $sw_hostname eq 'unknow';
 
-      my $sw_location = '';
+      my $sw_location = q{};
       for my $sw (@SWITCH) {
          next if $sw_hostname ne $sw->{hostname};
@@ -1058,5 +1058,5 @@
          }
 
-      printf "%s: \"%s\"\n", $ip, $sw_location if not $sw_location eq '';
+      printf "%s: \"%s\"\n", $ip, $sw_location if not $sw_location eq q{};
       }
    return;
@@ -1090,8 +1090,8 @@
 
 sub cmd_search_mac_on_switch {
-   my $switch_name = shift || '';
-   my $mac_address = shift || '';
-
-   if ($switch_name eq '' or $mac_address eq '') {
+   my $switch_name = shift || q{};
+   my $mac_address = shift || q{};
+
+   if ($switch_name eq q{} or $mac_address eq q{}) {
       die "Usage: klask search-mac-on-switch SWITCH_NAME MAC_ADDRESS\n";
       }
@@ -1146,5 +1146,5 @@
 #   for my $one_computer ('194.254.66.254') {
    for my $one_router ( get_list_main_router(get_list_network()) ) {
-      my %resol_arp = resolve_ip_arp_host($one_router,'*','low');            # resolution arp
+      my %resol_arp = resolve_ip_arp_host($one_router, q{*}, q{low}); # resolution arp
       next DETECT_ALL_ROUTER if $resol_arp{mac_address} eq 'unknow';
       $where{$resol_arp{ipv4_address}} = find_all_switch_port($resol_arp{mac_address}); # retrouve les emplacements des routeurs
@@ -1179,5 +1179,5 @@
    ALL_SWITCH:
    for my $one_computer (@list_switch_ip) {
-      my %resol_arp = resolve_ip_arp_host($one_computer,'*','low'); # arp resolution
+      my %resol_arp = resolve_ip_arp_host($one_computer, q{*}, q{low}); # arp resolution
       next ALL_SWITCH if $resol_arp{mac_address} eq 'unknow';
 
@@ -1405,5 +1405,5 @@
          $l++;
 
-         print "\"location$b-$l\" [label = \"$building".'/'.join('\n',split(m{ / }xms, $loc))."\", color = black, fillcolor = orange, style = filled];\n";
+         print "\"location$b-$l\" [label = \"$building" . q{/} . join(q{\n}, split(m{ / }xms, $loc)) . "\", color = black, fillcolor = orange, style = filled];\n";
 #         print "\"location$b-$l\" [label = \"$building / $loc\", color = black, fillcolor = orange, style = filled];\n";
          print "\"building$b\" -> \"location$b-$l\" [len = 2, color = firebrick]\n";