Index: /trunk/src/civ.m
===================================================================
--- /trunk/src/civ.m	(revision 64)
+++ /trunk/src/civ.m	(revision 65)
@@ -3598,6 +3598,6 @@
        
 		s=-1; 
-        display(['!' civ1_exe ' -f ' filename_cmx ' > ' namelog])
-        eval(['!' civ1_exe ' -f ' filename_cmx ' > ' namelog]);
+        display(['!' civ1_exe ' -f ' filename_cmx ' > ' namelog ' &'])
+        eval(['!' civ1_exe ' -f ' filename_cmx ' > ' namelog ' &']);
 % 		if sge%dispatch computation on the cluster using interactive queue
 %           %  [s,w] = unix(['qrsh -q fast.q ' civ1_exe ' -f ' filename_cmx ' > ' namelog ' 2>&1' ]);
@@ -3760,6 +3760,6 @@
         dlmwrite(filename_cmx,textout,''); 
         s=-1;  
-        display(['!' civ2_exe ' -f ' filename_cmx ' > ' namelog])
-        eval(['!' civ2_exe ' -f ' filename_cmx ' > ' namelog]);    
+        display(['!' civ2_exe ' -f ' filename_cmx ' > ' namelog ' &'])
+        eval(['!' civ2_exe ' -f ' filename_cmx ' > ' namelog ' &']);    
      
 % 		if sge%dispatch computation on the cluster using interactive queue
@@ -3782,8 +3782,8 @@
         if test_interp==0
             cmd_PATCH=[patch_exe ' -f ' filename_nc ' -m ' nx_patch  ' -n ' ny_patch ' -ro ' rho_patch ' -nopt ' subdomain_patch ...
-            '  > ' namelog ' 2>&1']; % redirect standard output to the log file
+            '  > ' namelog ' 2>&1 &']; % redirect standard output to the log file
          else %nouveau programme patch
              cmd_PATCH=[patch_new_exe ' -f ' filename_nc ' -m ' nx_patch  ' -n ' ny_patch ' -ro ' rho_patch ...
-                ' -max ' thresh_value ' -nopt ' subdomain_patch  '  > ' namelog ' 2>&1']; % redirect standard output to the log file
+                ' -max ' thresh_value ' -nopt ' subdomain_patch  '  > ' namelog ' 2>&1 &']; % redirect standard output to the log file
         end
 
Index: /trunk/src/mouse_down.m
===================================================================
--- /trunk/src/mouse_down.m	(revision 64)
+++ /trunk/src/mouse_down.m	(revision 65)
@@ -38,11 +38,11 @@
 test_create=~testzoom && (isequal(MouseAction,'create_object') || isequal(MouseAction,'create_mask'));
 %test_cal=get(handles.cal,'Value');
-test_cal=isequal(MouseAction,'calib');
-test_ruler=isequal(MouseAction,'ruler');
-menu_coord=get(hhuvmat.transform_fct,'String');
-coord_choice=get(hhuvmat.transform_fct,'Value');
-coord_type=menu_coord{coord_choice};
-test_edit=isequal(MouseAction,'edit_object');
-test_edit_vect=isequal(MouseAction,'edit_vect');
+test_cal=strcmp(MouseAction,'calib');
+test_ruler=strcmp(MouseAction,'ruler');
+% menu_coord=get(hhuvmat.transform_fct,'String');
+% coord_choice=get(hhuvmat.transform_fct,'Value');
+% coord_type=menu_coord{coord_choice};
+test_edit=strcmp(MouseAction,'edit_object');
+test_edit_vect=strcmp(MouseAction,'edit_vect');
 xdisplay=[];%default
 ydisplay=[];%default
@@ -257,11 +257,11 @@
             geometry_calib('ListCoord_Callback',hObject,eventdata,hh_geometry_calib)
             data=read_geometry_calib(Coord);
-            if isequal(coord_type,'px')|isequal(coord_type,'');%px cordinates
+%             if isequal(coord_type,'px')|isequal(coord_type,'');%px cordinates
                 XCoord=data.Coord(:,4);
                 YCoord=data.Coord(:,5);
-            else %phys cordinates
-                XCoord=data.Coord(:,1);
-                YCoord=data.Coord(:,2);
-            end
+%             else %phys cordinates
+%                 XCoord=data.Coord(:,1);
+%                 YCoord=data.Coord(:,2);
+%             end
             hh=findobj('Tag','calib_points');           
             if isempty(hh)
Index: /trunk/src/mouse_motion.m
===================================================================
--- /trunk/src/mouse_motion.m	(revision 64)
+++ /trunk/src/mouse_motion.m	(revision 65)
@@ -89,16 +89,20 @@
                           (AxeData.Y<(xy(1,2)+AxeData.Mesh/3) & AxeData.Y>(xy(1,2)-AxeData.Mesh/3));%f
                     ivec=find(flag_vec);% search the selected vector index ivec
+                    hhh=findobj(haxes,'Tag','vector_marker');
                     if length(ivec)>0 
+                        %ivec=ivec(1);%choice the first selected vector if several are selected
                         if ~test_create
                             pointershape='arrow'; %mouse indicates  the detection of a vector
-                            hhh=findobj(haxes,'Tag','vector_marker');
+  
                             if isempty(hhh)
-                                line(AxeData.X(ivec),AxeData.Y(ivec),'Color','m','Tag','vector_marker','LineStyle','.','Marker','o','MarkerSize',AxeData.Mesh);
+                                set(currentfig,'CurrentAxes',haxes)
+                                rectangle('Curvature',[1 1],...
+                  'Position',[AxeData.X(ivec)-AxeData.Mesh AxeData.Y(ivec)/2-AxeData.Mesh/2 AxeData.Mesh AxeData.Mesh],'EdgeColor','m',...
+                  'LineStyle','-','Tag','vector_marker');
+%                                 line(AxeData.X(ivec),AxeData.Y(ivec),'Color','m','Tag','vector_marker','LineStyle','.','Marker','o','MarkerSize',AxeData.Mesh);
                             else
-                                set(hhh,'XData',AxeData.X(ivec))
-                                set(hhh,'YData',AxeData.Y(ivec))
+                                set(hhh,'Position',[AxeData.X(ivec)-AxeData.Mesh/2 AxeData.Y(ivec)-AxeData.Mesh/2 AxeData.Mesh AxeData.Mesh])
                             end
-                        end
-                        ivec=ivec(1);%choice the first selected vector if several are selected
+                        end                 
                         mouse.X=AxeData.X(ivec);
                         mouse.Y=AxeData.Y(ivec);
@@ -106,5 +110,5 @@
                         v_mouse=AxeData.V(ivec);
                         w_mouse=0; %default
-                        if isfield(AxeData,'W')&length(AxeData.W)>=ivec
+                        if isfield(AxeData,'W') & length(AxeData.W)>=ivec
                             w_text=[',  w=' num2str(AxeData.W(ivec),3)];
                         else
@@ -124,4 +128,8 @@
                         else
                             ff_text='';
+                        end
+                    else
+                        if ~isempty(hhh)
+                            delete(hhh)
                         end
                     end
Index: /trunk/src/name_generator.m
===================================================================
--- /trunk/src/name_generator.m	(revision 64)
+++ /trunk/src/name_generator.m	(revision 65)
@@ -60,23 +60,15 @@
     num_i2=num_i1; %default
 end
+if ~exist('num_j2','var') || isequal(num_i2,[]) 
+    num_j2=num_j1; %default
+end
 if ~exist('subdir','var')|| isempty(subdir) 
     subdir='' ; %default
 end
-%detection of mask or mean: filebase of the form [root '_' xxx 'm$$$'] with xxx a number and $$$ three characters
-% if length(filebase)>4 & filebase(end-3)=='m';
-%     basedouble=double(filebase);
-%     val=(48>basedouble)|(basedouble>57);% select the non-numerical characters
-%     i=length(filebase)-4;
-%     while val(i)==0 & i>0
-%         i=i-1;
-%     end
-%     nbslice=str2num(filebase(i+1:end-4));
-%     if ~isequal(nbslice,[]) 
-%         num_i1=mod(num_i1-1,nbslice)+1; %take the rest in the division
-%         if isequal(nom_type,'png_old')|isequal(nom_type,'#a')
-%             num_j1=1;% mask name must end by 'a'
-%         end
-%     end
-% end
+num_i1_out=num_i1;%default output
+num_j1_out=num_j1;%default output
+num_i2_out=num_i2;%default output
+num_j2_out=num_j2;%default output
+
 test_pairs=isequal(nom_type,'netc_old')| isequal(nom_type,'netc_2D') | isequal(nom_type,'netc_3D')| isequal(nom_type,'_i1-i2_j1-j2')| ...
   isequal(nom_type,'netc_series')| isequal(nom_type,'#_ab')| isequal(nom_type,'_i_j1-j2')| isequal(nom_type,'_i1-i2_j')| isequal(nom_type,'_i1-i2');
@@ -85,35 +77,40 @@
 if isequal(nom_type,'series_i')| isequal(nom_type,'_i');
         filename=[filebase '_' num2str(num_i1) ext];
- %       idetect=(exist(filename,'file')==2); 
+        num_i2_out=num_i1;
+        num_j1_out=[];
+        num_j2_out=[]; 
 elseif length(nom_type)==5 && isequal(nom_type(1:3),'_%0')&& isequal(nom_type(5),'d');
         filename=[filebase '_' num2str(num_i1,nom_type(2:5)) ext];
- %       idetect=(exist(filename,'file')==2); 
+        num_i2_out=num_i1;
+        num_j2_out=num_j1;
 elseif isequal(nom_type,'series_i_j')| isequal(nom_type,'_i_j')
         filename=[filebase '_' num2str(num_i1) '_' num2str(num_j1) ext];
- %       idetect=(exist(filename,'file')==2);
+        num_i2_out=num_i1;
+        num_j2_out=num_j1;
 elseif isequal(nom_type,'png_old')| isequal(nom_type,'#a')| isequal(nom_type,'#A')
         filename=[filebase num2str(num_i1,'%03d') num2stra(num_j1,nom_type) ext];
-   %     idetect=(exist(filename,'file')==2);
+        num_i2_out=num_i1;
+        num_j2_out=num_j1;
 elseif  length(nom_type)>=5 & isequal(nom_type(2:3),'%0') & isequal(nom_type(5),'d')  %isequal(nom_type,'_%04dA') %camera PCO Toulouse
         filename=[filebase nom_type(1) num2str(num_i1,nom_type(2:4)) num2stra(num_j1,nom_type) ext];
- %       idetect=(exist(filename,'file')==2);         
+        num_i2_out=num_i1;
+        num_j2_out=num_j1;   
 elseif isequal(nom_type,'raw_SMD') %suffix a, b, c without extension
         filename=[filebase num2str(num_i1,'%03d') num2stra(num_j1,nom_type)];
-%        idetect=(exist(filename,'file')==2);
+        num_i2_out=num_i1;
+        num_j2_out=num_j1;
 elseif isequal(nom_type,'ima_num')| isequal(nom_type,'#')
         filename=[filebase num2str(num_i1) ext];
-%        idetect=(exist(filename,'file')==2);
+        num_i2_out=num_i1;
+        num_j1_out=[];
+        num_j2_out=[];
 elseif length(nom_type)>=4 & isequal(nom_type(1:2),'%0') & isequal(nom_type(end),'d')
-            filename=[filebase num2str(num_i1,nom_type) ext]; %test number with a 0 before
-%            idetect=(exist(filename,'file')==2);
+        filename=[filebase num2str(num_i1,nom_type) ext]; %test number with a 0 before
+        num_i2_out=num_i1;
+        num_j1_out=[];
+        num_j2_out=[];
 
 %case of derived file indexing (e.g. netcdf files)
 elseif test_pairs
-    if (~exist('num_j2','var')| isequal(num_j2,[])) & test_2D
-          num_j2=num_j1+1; %default if num_j2 undefined
-    end
-    if (~exist('num_i2','var')| isequal(num_i2,[])) & test_3D
-          num_i2=num_i1+1; %default if num_i2 undefined
-    end
     filebasesub=filebase;
     % get the root name filebasesub for the netcdf files
@@ -123,12 +120,12 @@
     end
      %inexistant pair if num_i2=0 or num_j2=0
-    if isequal(num_i2,0)
-        filename=[filebasesub '*-*_' num2str(num_i1) ext];
-        return
-    end
-    if isequal(num_j2,0)
-        filename=[filebasesub '_' num2str(num_i1) '_*-*' ext];
-        return
-    end
+%     if isequal(num_i2,0)
+%         filename=[filebasesub '*-*_' num2str(num_i1) ext];
+%         return
+%     end
+%     if isequal(num_j2,0)
+%         filename=[filebasesub '_' num2str(num_i1) '_*-*' ext];
+%         return
+%     end
     % case of an imposed image pair (comp_input=1)
     if  (exist('comp_input','var') & isequal(comp_input,1)) 
@@ -139,4 +136,5 @@
                     filename=[filebasesub num2str(num_i1,'%03d') '_' num2stra(num_j1,nom_type) num2stra(num_j2,nom_type) ext];
                 end
+                num_i2_out=num_i1;
             elseif isequal(nom_type,'netc_2D')|isequal(nom_type,'_i_j1-j2')
                 if isequal(num2str(num_j1),num2str(num_j2))% case of displacements at the same time
@@ -145,4 +143,5 @@
                     filename=[filebasesub '_' num2str(num_i1) '_' num2str(num_j1) '-' num2str(num_j2) ext];
                 end
+                num_i2_out=num_i1;
             elseif isequal(nom_type,'netc_3D') || isequal(nom_type,'_i1-i2_j')
                 if isequal(num2str(num_i1),num2str(num_i2))% case of displacements at the same time
@@ -151,4 +150,5 @@
                     filename=[filebasesub '_' num2str(num_i1) '-' num2str(num_i2) '_' num2str(num_j1) ext];
                 end
+                num_j2_out=num_j1;
             elseif isequal(nom_type,'netc_series') || isequal(nom_type,'_i1-i2')
                 if isequal(num2str(num_i1),num2str(num_i2))% case of displacements at the same time
@@ -157,4 +157,5 @@
                     filename=[filebasesub '_' num2str(num_i1) '-' num2str(num_i2) ext];
                 end
+                num_j2_out=num_j1;
             elseif isequal(nom_type,'_i1-i2_j1-j2')
                 if isequal(num2str(num_i1),num2str(num_i2))% case of displacements at the same time
@@ -174,5 +175,5 @@
      % case of an image pair to determine (comp_input=0)
     else
-            [filename,num_i1,num_j1,num_i2,num_j2,idetect]=search_pair(filebasesub,num_i1,num_j1,num_i2,nom_type);
+            [filename,num_i1_out,num_j1_out,num_i2_out,num_j2_out,idetect]=search_pair(filebasesub,num_i1,num_j1,num_i2,nom_type);
     end
     
@@ -216,5 +217,5 @@
             idetect=(exist(filename,'file')==2);
         else
-            [filename,num_i1,num_j1,num_i2,num_j2,idetect]=search_pair(filebasesub,num_i1,num_j1,num_i2,nom_type);             
+            [filename,num_i1_out,num_j1_out,num_i2_out,num_j2_out,idetect]=search_pair(filebasesub,num_i1,num_j1,num_i2,nom_type);             
         end
     end
@@ -229,8 +230,4 @@
     idetect=(exist(filename,'file')==2);  
 end
-num_i1_out=num_i1;
-num_j1_out=num_j1;
-if exist('num_i2','var'), num_i2_out=num_i2; else, num_i2_out=[]; end;
-if exist('num_j2','var'), num_j2_out=num_j2; else, num_j2_out=[]; end;
 if ~isequal(subdir,'?'), subdir_out=subdir; else, subdir_out='';end;
 
Index: /trunk/src/uvmat.m
===================================================================
--- /trunk/src/uvmat.m	(revision 64)
+++ /trunk/src/uvmat.m	(revision 65)
@@ -626,15 +626,8 @@
 update_rootinfo(hObject,eventdata,handles)
 
-%-------------------------------------------------------------------
-%-- called by action in FileIndex edit box
-%-------------------------------------------------------------------
-function FileIndex_Callback(hObject, eventdata, handles)
-NomType_str=get(handles.FileIndex,'String') ;
-[P,F,str1,str2,str_a,str_b]=name2display(['xx' NomType_str get(handles.FileExt,'String')]);
-% display the new index values on the counters
-set(handles.i1,'String',str1); 
-set(handles.i2,'String',str2);
-set(handles.j1,'String',str_a);
-set(handles.j2,'String',str_b);
+
+
+
+
 
 %-------------------------------------------------------------------
@@ -1670,5 +1663,5 @@
      num1=num1+increment;
      num2=num2+increment;
-     [filename,num1,num_a,num2,num_b]=name_generator(filebase,num1,num_a,FileExt,NomType,comp_input,num2,num_b,subdir);
+     [filename,num1,num_a,num2,num_b]=name_generator(filebase,num1,num_a,FileExt,NomType,comp_input,num2,num_b,subdir)
      if sub_value% set the second field name and indices
         num1_1=num1_1+increment;
@@ -1691,5 +1684,5 @@
 %         end
     end
-    filename=name_generator(filebase,num1,num_a,FileExt,NomType,comp_input,num2,num_b,subdir);
+    [filename,num1,num_a,num2,num_b]=name_generator(filebase,num1,num_a,FileExt,NomType,comp_input,num2,num_b,subdir);
 end
 
@@ -1745,13 +1738,23 @@
 index_fields=get(handles.Fields,'Value');% selected string index
 FieldName=list_fields{index_fields}; % selected field
+UvData=get(handles.uvmat,'UserData');
 if isequal(FieldName,'image')
-%     run0_Callback(hObject, eventdata, handles)%display the first image
-    UvData=get(handles.uvmat,'UserData');
-else
-    msgbox_uvmat('ERROR','an image or movie must be first introduced as input')
-    return
-end
-[ff,rr,filebase,xx,Ext,SubDir]=read_file_boxes(handles);
-NomType=get(handles.FileIndex,'UserData');
+    test_1=0;
+    [ff,rr,filebase,xx,Ext,SubDir]=read_file_boxes(handles);
+    NomType=get(handles.FileIndex,'UserData');
+else
+    list_fields=get(handles.Fields_1,'String');% list menu fields
+    index_fields=get(handles.Fields_1,'Value');% selected string index
+    FieldName=list_fields{index_fields}; % selected field
+    if isequal(FieldName,'image')
+        test_1=1;
+        [ff,rr,filebase,xx,Ext,SubDir]=read_file_boxes_1(handles);
+        NomType=get(handles.FileIndex_1,'UserData');
+    else
+        msgbox_uvmat('ERROR','an image or movie must be first introduced as input')
+        return
+    end
+end
+
 num_i1=stra2num(get(handles.i1,'String'));
 num_j1=stra2num(get(handles.j1,'String'));
@@ -1779,14 +1782,19 @@
 %read the second image
 Field.AName='image';
-Field.AX=UvData.Field.AX;
-Field.AY=UvData.Field.AY;
+if test_1
+    Field_a=UvData.Field_1;
+else
+    Field_a=UvData.Field;
+end
+Field_b.AX=Field_a.AX;
+Field_b.AY=Field_a.AY;
 % z index
 nbslice=str2double(get(handles.nb_slice,'String'));
 if ~isempty(nbslice)
-    Field.ZIndex=mod(num_i2-1,nbslice)+1;
-end
-Field.CoordType='px';
+    Field_b.ZIndex=mod(num_i2-1,nbslice)+1;
+end
+Field_b.CoordType='px';
 %determine the input file type
-if isfield(UvData,'MovieObject')
+if (test_1 && isfield(UvData,'MovieObject_1'))||(~test_1 && isfield(UvData,'MovieObject'))
     FileType='movie';
 elseif isequal(lower(Ext),'.avi')
@@ -1806,14 +1814,18 @@
 switch FileType
         case 'movie'
-            Field.A=read(UvData.MovieObject,num_i2);
+            if test_1
+                Field_b.A=read(UvData.MovieObject_1,num_i2);
+            else
+                Field_b.A=read(UvData.MovieObject,num_i2);
+            end
         case 'avi'
             mov=aviread(imaname_1,num_i2);
-            Field.A=frame2im(mov(1));
+            Field_b.A=frame2im(mov(1));
         case 'vol'
-            Field.A=imread(imaname_1);
+            Field_b.A=imread(imaname_1);
         case 'multimage'
-            Field.A=imread(imaname_1,num_i2);
+            Field_b.A=imread(imaname_1,num_i2);
         case 'image'
-            Field.A=imread(imaname_1);
+            Field_b.A=imread(imaname_1);
 end 
 if get(handles.slices,'Value')
@@ -1828,6 +1840,8 @@
 transform=transform_list{choice_value};
 if  ~isequal(transform_name,'') && ~isequal(transform_name,'px')
-    if isfield(UvData,'XmlData') && isfield(UvData.XmlData,'GeometryCalib')%use geometry calib recorded from the ImaDoc xml file as first priority
-        Field=transform(Field,UvData.XmlData);
+    if test_1 && isfield(UvData,'XmlData_1') && isfield(UvData.XmlData_1,'GeometryCalib')%use geometry calib recorded from the ImaDoc xml file as first priority
+        Field_b=transform(Field_b,UvData.XmlData_1);
+    elseif ~test_1 && isfield(UvData,'XmlData') && isfield(UvData.XmlData,'GeometryCalib')%use geometry calib
+        Field_b=transform(Field_b,UvData.XmlData);
     end
 end
@@ -1840,7 +1854,7 @@
 while get(handles.speed,'Value')~=0 && isequal(get(handles.movie_pair,'BusyAction'),'queue')%isequal(get(handles.run0,'BusyAction'),'queue'); % enable STOP command
     % read and plot the series of images in non erase mode
-    set(hima,'CData',Field.A); 
+    set(hima,'CData',Field_b.A); 
     pause(1.02-get(handles.speed,'Value'));% wait for next image
-    set(hima,'CData',UvData.Field.A);
+    set(hima,'CData',Field_a.A);
     pause(1.02-get(handles.speed,'Value'));% wait for next image
 end
@@ -1966,9 +1980,10 @@
 sub_value=get(handles.SubField,'Value');
 FileType_1='none';%default
-%if sub_value==1
+%if sub_value==
+filename_1
 if ~isempty(filename_1)
     % test for a constant second field (comparison with a fixed field)
     NomType_1=get(handles.FileIndex_1,'UserData');
-    Ext_1=get(handles.FileExt_1,'String');
+    Ext_1=get(handles.FileExt_1,'String')
     % determine the input file type
     if isequal(Ext_1,'.nc')||isequal(Ext_1,'.cdf')
@@ -1984,5 +1999,5 @@
         FieldName_1='image';
     else 
-       form=imformats(Ext([2:end]));
+       form=imformats(Ext_1([2:end]));
        if ~isempty(form)% if the extension corresponds to an image format recognized by Matlab
            if isequal(NomType_1,'*');
@@ -2064,12 +2079,15 @@
             A=read(UvData.MovieObject_1,num_i1);
         case 'avi'
-            mov=aviread(filename,num_i1);
+            mov=aviread(filename_1,num_i1);
             A=frame2im(mov(1));
         case 'vol'
-            A=imread(filename);
+            A=imread(filename_1);
         case 'multimage'
-            A=imread(filename,num_i1);
+            A=imread(filename_1,num_i1);
         case 'image'
-            A=imread(filename);
+            A=imread(filename_1);
+        case 'netcdf'
+        otherwise
+            errormsg=['unknown input file type ' filename_1];
     end 
     npxy=size(A);
@@ -2498,11 +2516,16 @@
     set(handles.MaxA,'String','255')
 end
-IndexObj=get(handles.list_object_1,'Value');
-Object=UvData.Object;
-IndexObj=min(IndexObj,numel(Object));
-for iobj=[1 IndexObj]
-    if ~isempty(Object{iobj})%& isfield(Object{iobj},'plotaxes')& ishandle(Object{iobj}.plotaxes)
+IndexObj(1)=get(handles.list_object_1,'Value');
+if IndexObj(1)> numel(UvData.Object)
+    IndexObj(1)=1;
+end
+IndexObj_2=get(handles.list_object_2,'Value');
+if IndexObj_2 <= numel(UvData.Object)
+    IndexObj(2)=IndexObj_2;
+end
+for iobj=IndexObj
+    if ~isempty(UvData.Object{iobj})%& isfield(Object{iobj},'plotaxes')& ishandle(Object{iobj}.plotaxes)
         %Projeter les champs sur l'objet:*
-        ObjectData=proj_field(UvData.Field,Object{iobj},iobj);
+        ObjectData=proj_field(UvData.Field,UvData.Object{iobj},iobj);
    
         %use of mask
@@ -2554,6 +2577,6 @@
         if ~isempty(ObjectData)
             haxes=[];%default
-            if isfield(Object{iobj},'plotaxes')
-                haxes=Object{iobj}.plotaxes;%axes used for representing the projection on the object
+            if isfield(UvData.Object{iobj},'plotaxes')
+                haxes=UvData.Object{iobj}.plotaxes;%axes used for representing the projection on the object
             end
             PosColorbar=[];%default: no colorbar
@@ -4169,6 +4192,4 @@
 IndexObj=get(handles.list_object_1,'Value');
 str_1=list_str{IndexObj};
-% set(handles.list_object_1,'BackgroundColor',[1 1 0]) 
-% set(handles.list_object_2,'BackgroundColor',[1 1 1]) 
 val_2=get(handles.list_object_2,'Value');
 str_2=get(handles.list_object_2,'String');